/*
student              Paul Diac
complexitate timp    O(Q * M)
complexitate memorie O(1)
punctaj              50/100
*/

#include <stdio.h>

FILE *fin = fopen("sir.in", "rt");
FILE *fout = fopen("sir.out", "wt");

int X0, A, B, M, Q, Per;
long long Pi;

int f(int X)
{
	return ((long long) A * X + B) % M;
}

int main()
{
	fscanf(fin, "%d %d %d %d %d", &X0, &A, &B, &M, &Q);

	int X = X0;
	int i = 0;

	for (; i == 0 || X != X0; i++)
		X = f(X);

	int Per = i;
	//printf("Per = %d\n", Per);

	for (i = 0; i < Q; i++)
	{
		fscanf(fin, "%I64d", &Pi);

		Pi %= Per;
		X = X0;
		for (int j = 0; j < Pi; j++)
			X = f(X);

		fprintf(fout, "%d ", X);
	}
	fprintf(fout, "\n");
	fclose(fin);
	fclose(fout);
	return 0;
}
