/*
student              Paul Diac
complexitate timp    O(Q * M)
complexitate memorie O(M)
punctaj              30/100
*/

#include <stdio.h>
#define MMax 5000

FILE *fin = fopen("sir.in", "rt");
FILE *fout = fopen("sir.out", "wt");

int X0, A, B, M, Q;
long long Pi;
int uz[MMax], per, tail;

int f(int X)
{
	return ((long long) X * A + B) % M;
}

int main()
{
	fscanf(fin, "%d %d %d %d %d", &X0, &A, &B, &M, &Q);
	
	for (int i = 0; i < M; i++)
		uz[i] = -1;
	uz[X0] = 0;

	int i;
	int X = f(X0);
	for (i = 1; uz[X] == -1; i++)
	{
		uz[X] = i;
		X = f(X);
	}

	tail = uz[X];
	per = i - uz[X];

	//printf("tail = %d per = %d\n", tail, per);

	for (i = 0; i < Q; i++)
	{
		fscanf(fin, "%I64d", &Pi);

		if (Pi > tail)
			Pi = (Pi - tail) % per + tail;

		X = X0;
		while (Pi--)
			X = f(X);

		fprintf(fout, "%d ", X);
	}
	fprintf(fout, "\n");
	fclose(fin);
	fclose(fout);
	return 0;
}
